import React from 'react';
export declare class Dropdown extends React.Component<Dropdown.Props, any> {
    getTransitionName(): string;
    render(): JSX.Element;
}
export declare namespace Dropdown {
    type Trigger = 'click' | 'hover' | 'contextMenu';
    type Placement = 'topLeft' | 'topCenter' | 'topRight' | 'bottomLeft' | 'bottomCenter' | 'bottomRight';
    interface Props {
        prefixCls?: string;
        className?: string;
        overlayStyle?: React.CSSProperties;
        overlayClassName?: string;
        openClassName?: string;
        visible?: boolean;
        disabled?: boolean;
        align?: Object;
        trigger?: Trigger | Trigger[];
        overlay?: React.ReactNode;
        transitionName?: string;
        placement?: Placement;
        forceRender?: boolean;
        mouseEnterDelay?: number;
        mouseLeaveDelay?: number;
        onVisibleChange?: (visible?: boolean) => void;
        getPopupContainer?: (triggerNode: Element) => HTMLElement;
    }
    const defaultProps: Props;
}
