import React from 'react';
import { IconProps as AntdIconProps } from 'antd/lib/icon';
export declare const Icon: React.SFC<Icon.Props>;
export declare namespace Icon {
    export interface IconData {
        width: number;
        height: number;
        pathData: string | string[];
    }
    type Diff<T extends keyof any, U extends keyof any> = ({
        [P in T]: P;
    } & {
        [P in U]: never;
    } & {
        [x: string]: never;
    })[T];
    type Overwrite<T, U> = Pick<T, Diff<keyof T, keyof U>> & U;
    interface IconProps {
        /**
         * Whether `icon` is a raw svg string.
         */
        svg?: boolean;
        type?: string | IconData;
    }
    export interface Props extends Overwrite<AntdIconProps, IconProps> {
    }
    export {};
}
